.TH XYPS 1L "28 September 1990"
.SH NAME
xyps \- convert xyplot output into PostScript
.SH SYNOPSIS
.B xyps
[
.B -?
] [
.B -d
] [
.B -l
] [
.B -c
] [
.B -e
] [
.B -p
.I prolog
] [
.B -f
.I font
] [
.B -h
.I header
] [
.I file
]
.SH DESCRIPTION
.I Xyps
reads the standard input, or
.I file
if supplied, and converts
.BR xyplot (1L)
commands generated with the \-s flag 
into PostScript.  The output of
.I xyps
can be sent to a PostScript printer.
By default
.I xyps
prints the date and the time the file was converted into PostScript
in the upper right corner of the page. A
header in the upper left corner can also be included.   The default fonts
are Helvetica for roman characters and Symbol for greek letters and
mathematical symbols.
.PP
To convert the commands
from
.BR xyplot (1L)
into PostScript 
.I xyps
prepends a prolog of commands into the PostScript file.  If no prolog name
is given in the command line 
.I xyps
looks for the name in the enviornment variable XYPRO.  If neither of these
are given it looks in the current directory for the file 
.I post
and also in a standard location.
.PP
If only one page of output is produced from the input file, the output
will be Encapsulated PostScript version 2.0 (an eps file).  If more than 
one page is generated then by the definition it cannot be Encapsulated
PostScript, and some structuring comments (PS-Adobe 2.0) will be printed.
These are enough for most page manipulation programs.  If the file is
to be incorporated into another document the date should be ommited (with
the -d flag) and no header should be included (no -h flag).
.SH OPTIONS
.TP
.B \-c
omit the standard prolog in the output. Many document preparation systems
allow you to download the prolog only once.
.TP 
.B \-d
omit the standard date on the upper right corner. Useful if the plot is
going to be incorporated into another document.
.TP
.B \-e
force the output not to be Encapsulated PostScript.
.TP
.B \-l
outputs the plot in landscape mode.  Useful for plots that have a small height
compared to their width.  It is optimized for 0.7 height.
.TP 
.B \-p
takes the next argument to be the name of the prolog file to be used.
.TP
.B \-f
takes the next argument to be the name of the standard font to be used. The
current options for the fonts are: 
.B cb
for Courier-Bold,
.B co
for Courier,
.B ho
for Helvetica-Oblique, and
.B tr
for Times-Roman.
.TP
.B \-h
takes the next argument to be a header string to be printed in the upper
left corner of the plot.  If spaces are used the whole string should be
enclosed in quotes.
.TP 
.B \-?
prints the name of the program and the patchlevel it was compiled with. If
issued from the shell must be quoted or escaped with a backslash.
.SH "SEE ALSO"
.PD 0
.PP
.I "Xyplot Users Guide",
.PP
.BR xyplot (1L),
.BR PostScript (5).
.PD 
.SH BUGS
.PP
The largest string that can be read is 512 characters long.
.PP
The time and date are of when the PostScript was generated and not when the
plot was printed or created.
.PP
The bounding box is only approximate and if strange label positions are used
it can be wrong.
.PP
Bug reports to ronnie@cardinal.lanl.gov
