/* $Id: nlabels.c,v 2.10 1997/11/13 19:52:05 jt Exp $ */
/* numeric labels */

extern int verbose;
#include <stdio.h>

#include <math.h>  /* fabs,log10,... */
#include "xyplot.h"

extern struct xy xd;
extern struct xy yd;
extern char xformat[];
extern char yformat[];
extern float numlblsize;
extern float overallsize;
extern int leftx;
extern int tickSize;

#define  TickSize  tickSize
 
static void num_lbl __P((char, char *, int));
static void digit __P((float, float, int, int *, int *));

static void nmark(c,p,x,format_s,n)
char c;
struct xy *p;
double x;
char *format_s;
int n;
{
    static char buf[128];
    int mark;
    
    if (p->xlb <= n*x && p->xub >= n*x) {
        sprintf(buf,format_s, n * x / p->xmult);
        mark = log10(n * x) * p->xa + p->xb;
        num_lbl(c, buf, mark);
    }
}

void 
axlab(c, p )
char c;
struct xy *p;
{
    int             mark;
    int             width, digits;
    char            buf[128];
    char            *format_s;
    float           x, xl, xu, delx;

    format_s = ((c=='x'||c=='X') ? xformat : yformat );

    if (p->xlogf) {
        int dotwofive=0;
        int dothree=0;
        int doonetwo=0;
        double quant = 10;
        if (p->xquant == 2)      dotwofive=1;
        else if (p->xquant == 3) dothree=1;
        else if (p->xquant == 1) doonetwo=1;
        else if (p->xquant > 10) quant=p->xquant;

        for (x = p->xllb; x <= p->xub; x *= quant) {
            nmark(c,p,x,format_s,1);
            if (doonetwo) {
                int j;
                for (j=2; j<10; ++j) {
                    nmark(c,p,x,format_s,j);
                }
            } else if (dotwofive) {
                nmark(c,p,x,format_s,2);
                nmark(c,p,x,format_s,5);
            } else if (dothree) {
                nmark(c,p,x,format_s,3);
            }
        }
    } else {                    /* its linear */
	outer_range(&xl,&xu,p);
	delx = fabs(p->xquant);
		
        digit(xl / p->xmult, xu / p->xmult, (int) ((xu - xl) / delx + 1.5),
              &width, &digits);
 
        for (x = xl; x <= xu; x += delx) {
	    if ( !in_range(x,p,EPS) )
		continue;
            sprintf(buf,format_s, x / p->xmult);
            /* zero is a special case */
            if (fabs(x/delx) < 0.001) {
                sprintf(buf,format_s,0.0);
            }
            if (verbose) fprintf(stderr,"axlab: %s -> %s\n",format_s,buf);
            mark = (*p->xf) (x) * p->xa + p->xb;
            num_lbl(c, buf, mark);
        }
    }
}
 
 
static void
num_lbl(c, buf, mark)
int  mark;
char c, *buf;
{
    char pri[BSIZ];
    int  i,dtik;

    gtou(buf, pri);
    switch (c) {
    case 'x':
	dtik = 2*neg(TickSize + 0.8*SSize);
	if (verbose) fprintf(stderr,"num_lbl: size=%g\n",NumlblSize);
        if (verbose) fprintf(stderr,"num_lbl: mark=%d %d\n",
                             mark, yd.xbot - (int) (2.5 * NumlblSize) - dtik);
        cascii(pri, mark, yd.xbot - (int) (2.5 * NumlblSize) - dtik,
               numlblSize);
        break;
    case 'X':
	dtik = 2*neg(TickSize + 0.8*SSize);
        cascii(pri, mark, yd.xtop + (int) (2.5 * NumlblSize) + dtik,
               numlblSize);
        break;
    case 'y':
	dtik = 2*neg(TickSize + 0.2*SSize);
	/* the 1.5 specifies how close y-axis label is to numbers */
        i = xd.xbot - (1.5 + 1.0*strlen(pri)) * NumlblSize - dtik;
        if (i<leftx) {
	    if (verbose) fprintf(stderr,"leftx = %d\n",i);
	    leftx = i;
	}
        rascii(pri, xd.xbot - (int) (NumlblSize) - dtik,
               mark, numlblSize);
        break;
    case 'Y':
	dtik = 2*neg(TickSize + 0.2*SSize);
        ascii(pri, xd.xtop + (int) (NumlblSize) + dtik,
	      mark, numlblSize);
        break;
    }
}

 
static void
digit(xlo,xhi,nlab,width,digits) 
float xlo,xhi;
int nlab,*width,*digits;
{
    double delta,x,y;
    int p,q;
    double r1,r2,r3;
    delta=(xhi-xlo)/(nlab-1);
    x=log10(delta);
    if(x>=0)  p= (int) x;
    else p= (int)( x-.9);
    y=pow((double)10,(double)(-p));
    r1=fabs((double)(xlo*y)); r2=fabs((double)(xhi*y));
    r3=max(r1,r2);
    q=(int)(1+log10(r3));
    /*	q=(int)(1+log10(max(fabs((double)(xlo*y)),fabs((double)(xhi*y))))); */
    if( p >=0 )  {*digits =0;
		  *width =p+q;}
    else {*digits= -p;
	  *width= 1+q+((-p)>q)*(1+(-p)-q);
      }
    if( xlo<0 || xhi < 0 ) (*width) ++;
    if( q==(-p) ) (*width) ++;
}
