/* $Id: plotcom.c,v 2.5 1995/05/29 01:46:00 jt Exp $ */
       /* produce intermediate code for the driver routines */

#include <stdio.h>
#include "xyplot.h"
extern FILE *outputfile;


/* move to a point */
void
move(x,y)
int x,y;
{
    fprintf(outputfile,"m %6d %6d\n",x,y);
}

/* plot a point */
void
point(x,y)
int x,y;
{
    fprintf(outputfile,"p %6d %6d\n",x,y);
}

/* line from here to there */
void
line(x1,y1,x2,y2)
int x1,y1,x2,y2;
{
    fprintf(outputfile,"l %6d %6d %6d %6d\n",x1,y1,x2,y2);
}

/* continue to a point */
void
cont(x,y)
{
    fprintf(outputfile,"n %6d %6d\n",x,y);
}

/* define plotting space */
void
space(x1,y1,x2,y2)
int x1,y1,x2,y2;
{ 
    fprintf(outputfile,"s %6d %6d %6d %6d\n",x1,y1,x2,y2);
}


/* make a label */
void
label(s)
char *s;
{
    fprintf(outputfile,"t %s\n",s);
}


/* change linestyle */
void
linemod(s)
char *s;
{
    fprintf(outputfile,"f %s\n",s); 
}

/* routine added -- DMD 8/2/95 */
/* change colour */
void
linecol(s)
char *s;
{
#ifdef COLOUR_SUPPORT
    fprintf(outputfile,"C %s\n",s); 
#endif
    return;
}
/* erase the screen */
void
erase()
{
    putc('e',outputfile);
    putc('\n',outputfile);
}

/* change width factor */
void
width(w)
float w;
{
    fprintf(outputfile,"w %.3f\n",w);
}



void
ascii(ptext,xorg,yorg,size)
char* ptext;
int xorg,yorg;
float size;
{
    fprintf(outputfile,"a %6d %6d %6f `%s\n",xorg,yorg,size,ptext);
}	


/* right justified string */
void
rascii(ptext,xorg,yorg,size)
char* ptext;
int xorg,yorg;
float size;
{
    fprintf(outputfile,"r %6d %6d %6f `%s\n",xorg,yorg,size,ptext);
}


/* centered text */
void
cascii(ptext,xorg,yorg,size)
char* ptext;
int xorg,yorg;
float size;
{
    fprintf(outputfile,"c %6d %6d %6f `%s\n",xorg,yorg,size,ptext);
}


/* centered vertical text */
void
cvascii(ptext,xorg,yorg,size)
char* ptext;
int xorg,yorg;
float size;
{
    fprintf(outputfile,"v %6d %6d %6f `%s\n",xorg,yorg,size,ptext);
}


